@ECHO OFF

REM Pour les accents => http://forum.telecharger.01net.com/forum/high-tech/ARCHIVE-L-ORDINATEUR-INDIVIDUEL/Logiciels/caracteres-accentues-resolu-sujet_4349_1.htm
REM  => 
REM  => 
REM  => 

SET NbParamsCount=0
for %%a in (%*) do @set /a NbParamsCount+=1
If %NbParamsCount% neq 1 GOTO ErrorScriptNbParams

IF "%1"=="2015" (
  SET REGEDIT_PATH_VERSION=14.0
) ELSE IF "%1"=="2012" (
  SET REGEDIT_PATH_VERSION=11.0
) ELSE IF "%1"=="2010" (
  SET REGEDIT_PATH_VERSION=10.0
) ELSE IF "%1"=="2008" (
  SET REGEDIT_PATH_VERSION=9.0
) ELSE (
  ECHO Version de Visual Studio non supporte !
  GOTO EndError
)

ECHO.
ECHO Determination du chemin d'installation de Visual Studio %1...

REM Il faut savoir si on est sur un systme 32 bits ou 64 bits : par dfaut 64 bits
SET SoftwareKey=SOFTWARE

REM Dans la boucle for : 2>nul permet de supprimer les messages d'erreur si la clef n'existe pas en redirigeant la sortie
REM standart dans le vide (plus joli) => En OS 32 bits, la clef n'existe pas, l'erreur suivante est gnre : 'Erreur: le systme n'a pas trouv la cl ou la valeur de Registre spcifie.'
REM Ceci vite cela. Mais '2>nul' n'est pas compris dans la boucle for, l'erreur suivante est gnre : '2> tait inattendu.'
REM > est utilis dans le langage, mais  chaque fois que l'on s'en sert dans une commande (ici la commande for), on doit spcifier ^ devant pour que
REM cmd ne l'interprte pas comme un "voici une nouvelle commande", il faut donc le placer avant le '>'

For /f "eol=; Skip=1 Tokens=1" %%i In ('Reg Query "HKLM\SOFTWARE\Wow6432Node" /ve 2^>nul') Do (
    ECHO OS 64 bits detecte...
    SET SoftwareKey=SOFTWARE\Wow6432Node
    Goto FindVisualStudioPath
)

ECHO OS 32 bits detecte...

REM Dtection de l'endroit o est install VisualStudio
:FindVisualStudioPath
@ECHO OFF
set KEY_NAME=HKLM\%SoftwareKey%\Microsoft\VisualStudio\%REGEDIT_PATH_VERSION%\Setup\VS
set VALUE_NAME=ProductDir

FOR /f "eol=; Skip=1 Tokens=2*" %%a IN ('REG QUERY "%KEY_NAME%" /v ProductDir 2^>nul') DO (
    SET VisualStudioPath="%%b"
    Goto VisualStudioPathDetecte
)

:VisualStudioPathDetecte
if defined VisualStudioPath (
    Goto CallVCVarSall
) else (
    Goto EndVisualStudioNotFound
)

:CallVCVarSall
REM Suppression des " en dbut et fin
SET VisualStudioPath=%VisualStudioPath:"=%

ECHO Appel de "%VisualStudioPath%VC\vcvarsall.bat"
CALL "%VisualStudioPath%VC\vcvarsall.bat"
Goto End

:EndVisualStudioNotFound
ECHO.
ECHO.
ECHO ------------------------------------------------------------------------------
ECHO Impossible de trouver le chemin de VisualStudio dans %KEY_NAME%\%VALUE_NAME% !
ECHO ------------------------------------------------------------------------------
Goto EndError

REM
REM  Erreur nombre de paramtres passs au batch
REM 
:ErrorScriptNbParams
ECHO.
ECHO.
ECHO -------------------------------------------------------------------------
ECHO Erreur, nombre de paramtres passs = %NbParamsCount% (attendu 1) !
ECHO   Param 1 = Version de Visual Studio
ECHO -------------------------------------------------------------------------
goto :EndError

:EndError
Exit /B 1

:End
Exit /B 0